unit Gmain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VCLTee.TeEngine, VCLTee.Series, Vcl.ExtCtrls, VCLTee.TeeProcs, VCLTee.Chart,
  Vcl.StdCtrls, System.Math, Jpeg, VclTee.TeeGDIPlus;

type
  TForm1 = class(TForm)
    FileOpen: TButton;
    GummaEdit: TLabeledEdit;
    GummaBtn: TButton;
    NormalBtn: TButton;
    Image1: TImage;
    Chart1: TChart;
    Series1: TLineSeries;
    OpenDialog1: TOpenDialog;
    FileSaveBtn: TButton;
    SaveDialog1: TSaveDialog;
    WICSaveBtn: TButton;
    procedure GummaBtnClick(Sender: TObject);
    procedure NormalBtnClick(Sender: TObject);
    procedure FileOpenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FileSaveBtnClick(Sender: TObject);
    procedure WICSaveBtnClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation
// uses WicUnit;

{$R *.dfm}
const
  VWIDTH  = 384;    // ftHg\TCY
  VHEIGHT = 384;    // ftHg\cTCY
var
  Gummadata         : array[0..255] of byte;            // K}[␳e[uz
  Gumma             : double;
  BWidth, BHeight   : integer;
  Vcrect            : TRect;
  BitmapD           : Tbitmap;                          // Windows rbg}bvC[W
  Gbitmap           : Tbitmap;                          // Windows rbg}bvC[W

//********************************************************************************************************
// t@C̎ނ𑽂邽߁ATWICImaggp܂
// TWICImage pł̂́AWindows XP SP3 ȏ OS ŁADirectX ^CgpĂꍇłB
//********************************************************************************************************

procedure TForm1.FileOpenClick(Sender: TObject);
var
  WIC         : TWICImage;                        // Delphi 2010 ȍ~
  XX, YY      : Integer;                          // for loop  GG |C^[vZp
begin
  FileOpen.Enabled := False;
  OpenDialog1.Filter := 'Image|*.bmp;*.jpg;*.tiff;*.tif;*.gif;*.png';
  if OpenDialog1.Execute then                     // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;
      try
        WIC.LoadFromFile(OpenDialog1.FileName);
        BitmapD.Assign(nil);
        BitmapD.PixelFormat := pf24bit;          // 24rbgtH[}bg
        BitmapD.SetSize(WIC.Width, WIC.Height);
        BitmapD.Canvas.Draw(0, 0, WIC);          // tH[}bgϊ 24rbgtH[}bgɂ܂
      finally
        WIC.Free;
      end;
    end
    else
    begin
      FileOpen.Enabled := True;
      exit;                                       // t@CIȂI
    end;

  BWidth   := BitmapD.Width;                      // rbg}bv擾
  BHeight  := BitmapD.Height;                     // rbg}bv擾

  Vcrect  := Rect(0, 0, VWIDTH, VHEIGHT); // rbg}bv\TCYʒuݒftHg
  Image1.Width  := VWIDTH;
  Image1.Height := VHEIGHT;
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clBtnFace;
  Image1.Canvas.FillRect(Vcrect);                 // Canvas 摜

  // rbg}bv\TCYݒ
  if BWidth > BHeight then begin                  // 傫ꍇ
    YY := round(VHEIGHT * BHeight / BWidth);
    Vcrect  := Rect(0, 0, VWIDTH, YY);            // rbg}bv\TCYʒuݒ
    Image1.Height := YY;
  end;

  if BWidth < BHeight then begin                  // c傫ꍇ
    XX := round(VWIDTH *  BWidth / BHeight);
    Vcrect  := Rect(0, 0, XX, VHEIGHT);           // rbg}bv\TCYʒuݒ
    Image1.Width := XX;
  end;
  // Open File \
  Image1.Canvas.StretchDraw(Vcrect,BitmapD);      // Xgb`\
  FileOpen.Enabled  := True;
  GummaBtn.Enabled  := True;
  NormalBtn.Enabled := True;
  FileSaveBtn.Enabled := False;
  WICSaveBtn.Enabled := False;
end;

//****************************************************************************
// TWICImage gpāAtH[}bgϊۑsƃ[[N̂
// TJpegimage gpĂ܂ Vcl.Graphics CΖ肠܂
//****************************************************************************
procedure TForm1.FileSaveBtnClick(Sender: TObject);
var
  JpImage    : TJpegimage;
  Fname      : String;
begin
  SaveDialog1.Filter := 'Jpeg|*.jpg;*.jpeg';
  if not SaveDialog1.Execute then exit;
  Fname := ChangeFileExt(SaveDialog1.FileName,'.Jpg');  // gq̐ݒ
  JpImage := TJpegimage.Create;
  try
    JpImage.Assign(Gbitmap);
    JpImage.SaveToFile(Fname);                          // w肳ꂽt@Cŏ
  finally
    JpImage.Free;
  end;
end;

procedure TForm1.WICSaveBtnClick(Sender: TObject);      // TWICImage̎gp
var
  WIC: TWICImage;
  Fname      : String;
begin
  SaveDialog1.Filter := 'Tiff|*.tif;*.tiff';
  if not SaveDialog1.Execute then exit;
  Fname := ChangeFileExt(SaveDialog1.FileName,'.tif');  // gq̐ݒ
  WIC := TWICImage.Create;
  try
    WIC.Assign(Gbitmap);
    WIC.ImageFormat := wiftiff;
    WIC.SaveToFile(Fname);
  finally
    WIC.Free;
  end;
end;


//*****************************************
// ݒ
//*****************************************
procedure TForm1.FormCreate(Sender: TObject);
begin
  BitmapD := Tbitmap.Create;                  // rbg}bvC[W̐
  Gbitmap := Tbitmap.Create;                  // rbg}bvC[W̐
  ClientHeight := 664;
  ClientWidth  := 512;
  GummaBtn.Enabled  := False;
  NormalBtn.Enabled := False;
  FileSaveBtn.Enabled := False;
  WICSaveBtn.Enabled := False;
end;

//*************************************
// I
//*************************************
procedure TForm1.FormDestroy(Sender: TObject);
begin
  BitmapD.Free;
  Gbitmap.Free;
end;

//*************************************************
// K}lC
//*************************************************
procedure TForm1.GummaBtnClick(Sender: TObject);
var
  II      : integer;
  CH      : integer;
  PD, PG  : PByteArray;                       // oCg̐ÓIzւ̃|C^ z̃TCÝA32,768
  XX, YY  : integer;
  MM      : integer;
begin
  Val(GummaEdit.Text,Gumma, CH);
  if CH <> 0 then begin
    application.MessageBox('͂Ɍ肪܂B','',0);
    exit;
  end;
  if Gumma <= 0 then begin
    application.MessageBox('K}̒lɃ[yу}CiX̒l͎wł܂B','',0);
    exit;
  end;
  GummaBtn.Enabled := False;

  Series1.Clear;                              // OtNA
  // ␳p ev[g쐬
  for II := 0 to 255 do begin
    Gummadata[II] := Round(255 * Power(II / 255, 1 / Gumma));   // lev[gf[^[쐬
    Series1.Add(Gummadata[II],'');                              // Otɒǉ\
  end;
  Chart1.Update;
  // ␳摜prbg}bv
  Gbitmap.Assign(nil);                          // rbg}bv
  Gbitmap.PixelFormat := pf24bit;
  Gbitmap.Width   := BWidth;
  Gbitmap.Height  := BHeight;
  // K}␳
  for YY := 0 to BHeight -1 do begin
    PG := GBitmap.Scanline[YY];                 // rbg}bvC|C^[擾
    PD := BitmapD.ScanLine[YY];
    for XX := 0 to BWidth - 1 do begin
      MM := XX * 3;
      PG[MM]      := Gummadata[PD[MM]];         // B  ev[g␳
      PG[MM + 1]  := Gummadata[PD[MM + 1]];     // G  ev[g␳
      PG[MM + 2]  := Gummadata[PD[MM + 2]];     // R  ev[g␳
    end;
  end;
  Image1.Canvas.StretchDraw(Vcrect,Gbitmap);      // Xgb`\
  GummaBtn.Enabled := True;
  FileSaveBtn.Enabled := True;
  WICSaveBtn.Enabled := True;
end;

procedure TForm1.NormalBtnClick(Sender: TObject);
var
  II: integer;
begin
  Series1.Clear;                                  // OtNA
  for II := 0 to 255 do begin                     // Ot\
    Gummadata[II] := II;                          // f[^[쐬=1
    Series1.Add(Gummadata[II],'');
  end;
  Image1.Canvas.StretchDraw(Vcrect,BitmapD);      // Xgb`\
  FileSaveBtn.Enabled := False;
end;

end.
